/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of LibRSVG.xs. Do not edit this file, edit LibRSVG.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "LibRSVG.xs"
/* ----------------------------------------------------------------
 * Original File Name:  LibRSVG.xs 
 * Creation Date:       04.02.2004
 * Description:         XS Glue for Perl 
 * -----------------------------------------------------------------
 * -----------------------------------------------------------------
 * Copyright (c) 2004 bestsolution.at Systemhaus GmbH
 * ----------------------------------------------------------------
*/

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"





/**
 * Methods below are copied from the librsvg2-package
 * from the file "rsvg-file-util.c"
 *
*/


#include "librsvg/rsvg.h"

#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <gdk-pixbuf/gdk-pixbuf-features.h>

#define SVG_BUFFER_SIZE (1024 * 8)

typedef enum {
    RSVG_SIZE_ZOOM,
    RSVG_SIZE_WH,
    RSVG_SIZE_WH_MAX,
    RSVG_SIZE_ZOOM_MAX
} RsvgSizeType;

struct RsvgSizeCallbackData
{
    RsvgSizeType type;
    double x_zoom;
    double y_zoom;
    gint width;
    gint height;
};

static void
rsvg_size_callback (int *width, int *height, gpointer  data)
{
    struct RsvgSizeCallbackData *real_data = (struct RsvgSizeCallbackData *) data;
    double zoomx, zoomy, zoom;

    switch (real_data->type) {
        case RSVG_SIZE_ZOOM:
            if (*width < 0 || *height < 0)
                return;

            *width = floor (real_data->x_zoom * *width + 0.5);
            *height = floor (real_data->y_zoom * *height + 0.5);
            return;

        case RSVG_SIZE_ZOOM_MAX:
            if (*width < 0 || *height < 0)
                return;

            *width = floor (real_data->x_zoom * *width + 0.5);
            *height = floor (real_data->y_zoom * *height + 0.5);

            if (*width > real_data->width || *height > real_data->height) {
                zoomx = (double) real_data->width / *width;
                zoomy = (double) real_data->height / *height;
                zoom = MIN (zoomx, zoomy);

                *width = floor (zoom * *width + 0.5);
                *height = floor (zoom * *height + 0.5);
            }
            return;

        case RSVG_SIZE_WH_MAX:
            if (*width < 0 || *height < 0)
                return;

            zoomx = (double) real_data->width / *width;
            zoomy = (double) real_data->height / *height;
            zoom = MIN (zoomx, zoomy);

            *width = floor (zoom * *width + 0.5);
            *height = floor (zoom * *height + 0.5);
            return;

        case RSVG_SIZE_WH:
        
        if (real_data->width != -1)
            *width = real_data->width;
            if (real_data->height != -1)
                *height = real_data->height;
            return;
    }

    g_assert_not_reached ();
}

static GdkPixbuf *
rsvg_pixbuf_from_file_with_size_data_ex (RsvgHandle * handle, const gchar * file_name, struct RsvgSizeCallbackData * data, GError ** error)
{
    guchar chars[SVG_BUFFER_SIZE];
    GdkPixbuf *retval;
    gint result;
    FILE *f = fopen (file_name, "rb");

    if (!f) {
        g_set_error (error, G_FILE_ERROR,
        g_file_error_from_errno (errno),
        g_strerror (errno));
        return NULL;
    }

    rsvg_handle_set_size_callback (handle, rsvg_size_callback, data, NULL);

    while ((result = fread (chars, 1, SVG_BUFFER_SIZE, f)) > 0)
        rsvg_handle_write (handle, chars, result, error);

    rsvg_handle_close (handle, error);
    retval = rsvg_handle_get_pixbuf (handle);

    fclose (f);	
    return retval;
}

static GdkPixbuf *
rsvg_pixbuf_from_file_with_size_data (const gchar * file_name, struct RsvgSizeCallbackData * data, GError ** error)
{
    RsvgHandle * handle = rsvg_handle_new ();
    GdkPixbuf * retval = rsvg_pixbuf_from_file_with_size_data_ex (handle, file_name, data, error);
    rsvg_handle_free (handle);
    return retval;
}


static GdkPixbuf *
rsvg_pixbuf_from_chars_with_size_data (const guchar * svg, struct RsvgSizeCallbackData * data, GError ** error)
{
    RsvgHandle * handle = rsvg_handle_new ();
    rsvg_handle_set_size_callback (handle, rsvg_size_callback, data, NULL);
    rsvg_handle_write (handle, svg, strlen( svg ), error);
    rsvg_handle_close (handle, error);
    GdkPixbuf *retval = rsvg_handle_get_pixbuf (handle);
    rsvg_handle_free (handle);

    return retval;
}

















GdkPixbuf *
rsvg_pixbuf_from_file (const gchar *file_name, GError     **error)
{
    return rsvg_pixbuf_from_file_at_size (file_name, -1, -1, error);
}

/*GdkPixbuf *
rsvg_pixbuf_from_chars (const gchar *svg, GError     **error)
{
    return rsvg_pixbuf_from_chars_at_size (svg, -1, -1, error);
}*/


GdkPixbuf *
rsvg_pixbuf_from_file_at_zoom (const gchar *file_name, double x_zoom, double y_zoom, GError **error)
{
    struct RsvgSizeCallbackData data;

    g_return_val_if_fail (file_name != NULL, NULL);
    g_return_val_if_fail (x_zoom > 0.0 && y_zoom > 0.0, NULL);

    data.type = RSVG_SIZE_ZOOM;
    data.x_zoom = x_zoom;
    data.y_zoom = y_zoom;
    
    return rsvg_pixbuf_from_file_with_size_data (file_name, &data, error);
}

GdkPixbuf *
rsvg_pixbuf_from_chars_at_zoom (const gchar *file_name, double x_zoom, double y_zoom, GError **error)
{
    struct RsvgSizeCallbackData data;

    g_return_val_if_fail (file_name != NULL, NULL);
    g_return_val_if_fail (x_zoom > 0.0 && y_zoom > 0.0, NULL);

    data.type = RSVG_SIZE_ZOOM;
    data.x_zoom = x_zoom;
    data.y_zoom = y_zoom;
    
    return rsvg_pixbuf_from_chars_with_size_data (file_name, &data, error);
}




GdkPixbuf  *
rsvg_pixbuf_from_file_at_zoom_with_max (const gchar  *file_name, double x_zoom, double y_zoom, gint max_width, gint max_height, GError **error)
{
    struct RsvgSizeCallbackData data;

    g_return_val_if_fail (file_name != NULL, NULL);
    g_return_val_if_fail (x_zoom > 0.0 && y_zoom > 0.0, NULL);

    data.type = RSVG_SIZE_ZOOM_MAX;
    data.x_zoom = x_zoom;
    data.y_zoom = y_zoom;
    data.width = max_width;
    data.height = max_height;

    return rsvg_pixbuf_from_file_with_size_data (file_name, &data, error);
}

GdkPixbuf  *
rsvg_pixbuf_from_chars_at_zoom_with_max (const gchar  *file_name, double x_zoom, double y_zoom, gint max_width, gint max_height, GError **error)
{
    struct RsvgSizeCallbackData data;

    g_return_val_if_fail (file_name != NULL, NULL);
    g_return_val_if_fail (x_zoom > 0.0 && y_zoom > 0.0, NULL);

    data.type = RSVG_SIZE_ZOOM_MAX;
    data.x_zoom = x_zoom;
    data.y_zoom = y_zoom;
    data.width = max_width;
    data.height = max_height;

    return rsvg_pixbuf_from_chars_with_size_data (file_name, &data, error);
}




GdkPixbuf *
rsvg_pixbuf_from_file_at_size (const gchar *file_name, gint width, gint height, GError **error)
{
    struct RsvgSizeCallbackData data;

    data.type = RSVG_SIZE_WH;
    data.width = width;
    data.height = height;

    return rsvg_pixbuf_from_file_with_size_data (file_name, &data, error);
}


GdkPixbuf *
rsvg_pixbuf_from_chars_at_size (const gchar *svg, gint width, gint height, GError **error)
{
    struct RsvgSizeCallbackData data;

    data.type = RSVG_SIZE_WH;
    data.width = width;
    data.height = height;

    return rsvg_pixbuf_from_chars_with_size_data (svg, &data, error);
}

GdkPixbuf *
rsvg_pixbuf_from_chars (const gchar *svg, GError     **error)
{
    return rsvg_pixbuf_from_chars_at_size (svg, -1, -1, error);
}




GdkPixbuf  *
rsvg_pixbuf_from_file_at_max_size (const gchar *file_name, gint max_width, gint max_height, GError **error)
{
    struct RsvgSizeCallbackData data;

    data.type = RSVG_SIZE_WH_MAX;
    data.width = max_width;
    data.height = max_height;
        
    return rsvg_pixbuf_from_file_with_size_data (file_name, &data, error);
}

GdkPixbuf  *
rsvg_pixbuf_from_chars_at_max_size (const gchar *file_name, gint max_width, gint max_height, GError **error)
{
    struct RsvgSizeCallbackData data;

    data.type = RSVG_SIZE_WH_MAX;
    data.width = max_width;
    data.height = max_height;
        
    return rsvg_pixbuf_from_chars_with_size_data (file_name, &data, error);
}




int
save( int quality, char * format, GdkPixbuf * pixbuf, char * filename ) {
    char * quality_str;
    int rv;
    
    if (strcmp (format, "jpeg") != 0 || (quality < 1 || quality > 100)) /* is a png or is an invalid quality */
    {
        rv = gdk_pixbuf_save (pixbuf, filename, format, NULL, NULL);
    }
    else 
    {
        quality_str = g_strdup_printf ("%d", quality);
        rv = gdk_pixbuf_save (pixbuf, filename, format, NULL, "quality", quality_str, NULL);
        g_free (quality_str);
    }
    
    return rv;
}

void add_if_writable(GdkPixbufFormat *data, AV *formats) {
    
    if (gdk_pixbuf_format_is_writable (data)) {
        av_push( formats, newSVpv( gdk_pixbuf_format_get_name ( data ), 0 ) );
    }
}

void add_to_formats_list(GdkPixbufFormat *data, AV *formats){
    av_push( formats, newSVpv( gdk_pixbuf_format_get_name ( data ), 0 ) );
}


/*void add_mimetypes_to_formats(GdkPixbufFormat *data, HV *formats){
    char *name = gdk_pixbuf_format_get_name ( data );
    
    // gchar **mime_types  = gdk_pixbuf_format_get_mime_types(data);
    // AV *mime_types = (AV *)newAV();
    
    // g_strfreev( mime_types );
    
    // hv_store(  );
}

void add_mime_type_to_list(  ){
    
}

*/

typedef struct {
  GdkPixbuf *pixbuf;
} SVGLibRSVG;

#line 382 "LibRSVG.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 526 "LibRSVG.c"

XS_EUPXS(XS_Image__LibRSVG_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Image__LibRSVG_new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "CLASS");
    {
	char *	CLASS = (char *)SvPV_nolen(ST(0))
;
	SVGLibRSVG *	RETVAL;
#line 384 "LibRSVG.xs"
        Newz(0, RETVAL, 1, SVGLibRSVG);
        RETVAL->pixbuf = NULL;
#line 541 "LibRSVG.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, CLASS, (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Image__LibRSVG_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Image__LibRSVG_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	SVGLibRSVG *	THIS;

        if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG)
        {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
          THIS = INT2PTR(SVGLibRSVG *, tmp);
        }
        else
          Perl_croak(aTHX_ "Image::LibRSVG::DESTROY(): THIS is not a blessed SV reference")
;
#line 392 "LibRSVG.xs"
        if( THIS->pixbuf ) {
            g_object_unref ( G_OBJECT (THIS->pixbuf) );
            THIS->pixbuf = NULL;
        }
#line 575 "LibRSVG.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Image__LibRSVG_getSupportedFormats); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Image__LibRSVG_getSupportedFormats)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "CLASS");
    {
	char *	CLASS = (char *)SvPV_nolen(ST(0))
;
	SV *	RETVAL;
#line 404 "LibRSVG.xs"
        GSList *formats = gdk_pixbuf_get_formats ();
        AV * results = (AV *)sv_2mortal( (SV *)newAV() );

        g_slist_foreach ( formats, add_if_writable, results );
        g_slist_free (formats);
        RETVAL = newRV((SV *)results);
#line 598 "LibRSVG.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Image__LibRSVG_getKnownFormats); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Image__LibRSVG_getKnownFormats)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "CLASS");
    {
	char *	CLASS = (char *)SvPV_nolen(ST(0))
;
	SV *	RETVAL;
#line 417 "LibRSVG.xs"
        GSList *formats = gdk_pixbuf_get_formats ();
        AV * results = (AV *)sv_2mortal( (SV *)newAV() );

        g_slist_foreach ( formats, add_to_formats_list, results );
        g_slist_free (formats);
        RETVAL = newRV((SV *)results);
#line 623 "LibRSVG.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Image__LibRSVG_isFormatSupported); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Image__LibRSVG_isFormatSupported)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "CLASS, format_string");
    {
	char *	format_string = (char *)SvPV_nolen(ST(1))
;
	char *	CLASS = (char *)SvPV_nolen(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 430 "LibRSVG.xs"
        I32 formatsi = 0;
        int i;

        AV * results = (AV *)sv_2mortal( (SV *)newAV() );
        GSList *formats = gdk_pixbuf_get_formats ();

        g_slist_foreach ( formats, add_if_writable, results );
        g_slist_free (formats);

        formatsi = av_len( results );

        RETVAL = 0;

        for( i = 0; i <= formatsi; i++ ){
            STRLEN l;
            char * fn = SvPV( *av_fetch(results, i, 0), l);

            if( strcmp( fn, format_string ) == 0 ) {
                RETVAL = 1;
                break;
            }
        }
#line 667 "LibRSVG.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Image__LibRSVG_isGzCompressionSupported); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Image__LibRSVG_isGzCompressionSupported)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "CLASS");
    {
	char *	CLASS = (char *)SvPV_nolen(ST(0))
;
	bool	RETVAL;
#line 458 "LibRSVG.xs"
            RETVAL = 1;
#line 686 "LibRSVG.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Image__LibRSVG_convert); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Image__LibRSVG_convert)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 6)
       croak_xs_usage(cv,  "THIS, svgfile, bitmapfile, dpi=0, format=\"png\", quality=100");
    {
	char *	svgfile = (char *)SvPV_nolen(ST(1))
;
	char *	bitmapfile = (char *)SvPV_nolen(ST(2))
;
	double	dpi;
	char *	format;
	int	quality;
	SVGLibRSVG *	THIS;
	int	RETVAL;
	dXSTARG;

	if (items < 4)
	    dpi = 0;
	else {
	    dpi = (double)SvNV(ST(3))
;
	}

	if (items < 5)
	    format = "png";
	else {
	    format = (char *)SvPV_nolen(ST(4))
;
	}

	if (items < 6)
	    quality = 100;
	else {
	    quality = (int)SvIV(ST(5))
;
	}

        if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG)
        {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
          THIS = INT2PTR(SVGLibRSVG *, tmp);
        }
        else
          Perl_croak(aTHX_ "Image::LibRSVG::convert(): THIS is not a blessed SV reference")
;
#line 474 "LibRSVG.xs"
        GdkPixbuf *pixbuf;

        g_type_init ();

        if (dpi > 0.) {
            rsvg_set_default_dpi (dpi);
        }

        pixbuf = rsvg_pixbuf_from_file( svgfile, NULL );

        if( pixbuf ) {
            RETVAL = save( quality, format, pixbuf, bitmapfile );
            g_object_unref ( G_OBJECT (pixbuf) );
        } else {
            RETVAL = 0;
        }
#line 757 "LibRSVG.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Image__LibRSVG_convertAtZoom); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Image__LibRSVG_convertAtZoom)
{
    dVAR; dXSARGS;
    if (items < 5 || items > 8)
       croak_xs_usage(cv,  "THIS, svgfile, bitmapfile, x_zoom, y_zoom, dpi=0, format=\"png\", quality=100");
    {
	char *	svgfile = (char *)SvPV_nolen(ST(1))
;
	char *	bitmapfile = (char *)SvPV_nolen(ST(2))
;
	double	x_zoom = (double)SvNV(ST(3))
;
	double	y_zoom = (double)SvNV(ST(4))
;
	double	dpi;
	char *	format;
	int	quality;
	SVGLibRSVG *	THIS;
	int	RETVAL;
	dXSTARG;

	if (items < 6)
	    dpi = 0;
	else {
	    dpi = (double)SvNV(ST(5))
;
	}

	if (items < 7)
	    format = "png";
	else {
	    format = (char *)SvPV_nolen(ST(6))
;
	}

	if (items < 8)
	    quality = 100;
	else {
	    quality = (int)SvIV(ST(7))
;
	}

        if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG)
        {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
          THIS = INT2PTR(SVGLibRSVG *, tmp);
        }
        else
          Perl_croak(aTHX_ "Image::LibRSVG::convertAtZoom(): THIS is not a blessed SV reference")
;
#line 504 "LibRSVG.xs"
        GdkPixbuf *pixbuf;

        g_type_init ();

        if (dpi > 0.) {
            rsvg_set_default_dpi (dpi);
        }

        pixbuf = rsvg_pixbuf_from_file_at_zoom( svgfile, x_zoom, y_zoom, NULL );

        if( pixbuf ){
            RETVAL = save( quality, format, pixbuf, bitmapfile );
            g_object_unref ( G_OBJECT (pixbuf) );
        } else {
            RETVAL = 0;
        }
#line 832 "LibRSVG.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Image__LibRSVG_convertAtMaxSize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Image__LibRSVG_convertAtMaxSize)
{
    dVAR; dXSARGS;
    if (items < 5 || items > 8)
       croak_xs_usage(cv,  "THIS, svgfile, bitmapfile, width, height, dpi=0, format=\"png\", quality=100");
    {
	char *	svgfile = (char *)SvPV_nolen(ST(1))
;
	char *	bitmapfile = (char *)SvPV_nolen(ST(2))
;
	int	width = (int)SvIV(ST(3))
;
	int	height = (int)SvIV(ST(4))
;
	double	dpi;
	char *	format;
	int	quality;
	SVGLibRSVG *	THIS;
	int	RETVAL;
	dXSTARG;

	if (items < 6)
	    dpi = 0;
	else {
	    dpi = (double)SvNV(ST(5))
;
	}

	if (items < 7)
	    format = "png";
	else {
	    format = (char *)SvPV_nolen(ST(6))
;
	}

	if (items < 8)
	    quality = 100;
	else {
	    quality = (int)SvIV(ST(7))
;
	}

        if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG)
        {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
          THIS = INT2PTR(SVGLibRSVG *, tmp);
        }
        else
          Perl_croak(aTHX_ "Image::LibRSVG::convertAtMaxSize(): THIS is not a blessed SV reference")
;
#line 533 "LibRSVG.xs"
        GdkPixbuf *pixbuf;

        g_type_init ();

        if (dpi > 0.) {
            rsvg_set_default_dpi (dpi);
        }

        pixbuf = rsvg_pixbuf_from_file_at_max_size( svgfile, width, height, NULL );

        if( pixbuf ){
            RETVAL = save( quality, format, pixbuf, bitmapfile );
            g_object_unref ( G_OBJECT (pixbuf) );
        } else {
            RETVAL = 0;
        }
#line 907 "LibRSVG.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Image__LibRSVG_convertAtSize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Image__LibRSVG_convertAtSize)
{
    dVAR; dXSARGS;
    if (items < 5 || items > 8)
       croak_xs_usage(cv,  "THIS, svgfile, bitmapfile, width, height, dpi=0, format=\"png\", quality=100");
    {
	char *	svgfile = (char *)SvPV_nolen(ST(1))
;
	char *	bitmapfile = (char *)SvPV_nolen(ST(2))
;
	int	width = (int)SvIV(ST(3))
;
	int	height = (int)SvIV(ST(4))
;
	double	dpi;
	char *	format;
	int	quality;
	SVGLibRSVG *	THIS;
	int	RETVAL;
	dXSTARG;

	if (items < 6)
	    dpi = 0;
	else {
	    dpi = (double)SvNV(ST(5))
;
	}

	if (items < 7)
	    format = "png";
	else {
	    format = (char *)SvPV_nolen(ST(6))
;
	}

	if (items < 8)
	    quality = 100;
	else {
	    quality = (int)SvIV(ST(7))
;
	}

        if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG)
        {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
          THIS = INT2PTR(SVGLibRSVG *, tmp);
        }
        else
          Perl_croak(aTHX_ "Image::LibRSVG::convertAtSize(): THIS is not a blessed SV reference")
;
#line 562 "LibRSVG.xs"
        GdkPixbuf *pixbuf;

        g_type_init ();

        if (dpi > 0.) {
            rsvg_set_default_dpi (dpi);
        }

        pixbuf = rsvg_pixbuf_from_file_at_size( svgfile, width, height, NULL );

        if( pixbuf ){
            RETVAL = save( quality, format, pixbuf, bitmapfile );
            g_object_unref ( G_OBJECT (pixbuf) );
        } else {
            RETVAL = 0;
        }
#line 982 "LibRSVG.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Image__LibRSVG_convertAtZoomWithMax); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Image__LibRSVG_convertAtZoomWithMax)
{
    dVAR; dXSARGS;
    if (items < 7 || items > 10)
       croak_xs_usage(cv,  "THIS, svgfile, bitmapfile, x_zoom, y_zoom, width, height, dpi=0, format=\"png\", quality=100");
    {
	char *	svgfile = (char *)SvPV_nolen(ST(1))
;
	char *	bitmapfile = (char *)SvPV_nolen(ST(2))
;
	double	x_zoom = (double)SvNV(ST(3))
;
	double	y_zoom = (double)SvNV(ST(4))
;
	int	width = (int)SvIV(ST(5))
;
	int	height = (int)SvIV(ST(6))
;
	double	dpi;
	char *	format;
	int	quality;
	SVGLibRSVG *	THIS;
	int	RETVAL;
	dXSTARG;

	if (items < 8)
	    dpi = 0;
	else {
	    dpi = (double)SvNV(ST(7))
;
	}

	if (items < 9)
	    format = "png";
	else {
	    format = (char *)SvPV_nolen(ST(8))
;
	}

	if (items < 10)
	    quality = 100;
	else {
	    quality = (int)SvIV(ST(9))
;
	}

        if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG)
        {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
          THIS = INT2PTR(SVGLibRSVG *, tmp);
        }
        else
          Perl_croak(aTHX_ "Image::LibRSVG::convertAtZoomWithMax(): THIS is not a blessed SV reference")
;
#line 593 "LibRSVG.xs"
        GdkPixbuf *pixbuf;

        g_type_init ();

        if (dpi > 0.) {
            rsvg_set_default_dpi (dpi);
        }

        pixbuf = rsvg_pixbuf_from_file_at_zoom_with_max( svgfile, x_zoom, y_zoom, width, height, NULL );

        if( pixbuf ){
            RETVAL = save( quality, format, pixbuf, bitmapfile );
            g_object_unref ( G_OBJECT (pixbuf) );
        } else {
            RETVAL = 0;
        }
#line 1061 "LibRSVG.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Image__LibRSVG_loadFromFile); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Image__LibRSVG_loadFromFile)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "THIS, svgfile, dpi=0");
    {
	char *	svgfile = (char *)SvPV_nolen(ST(1))
;
	double	dpi;
	SVGLibRSVG *	THIS;
	int	RETVAL;
	dXSTARG;

	if (items < 3)
	    dpi = 0;
	else {
	    dpi = (double)SvNV(ST(2))
;
	}

        if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG)
        {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
          THIS = INT2PTR(SVGLibRSVG *, tmp);
        }
        else
          Perl_croak(aTHX_ "Image::LibRSVG::loadFromFile(): THIS is not a blessed SV reference")
;
#line 621 "LibRSVG.xs"
        g_type_init ();

        if (dpi > 0.) {
            rsvg_set_default_dpi (dpi);
        }

        if( THIS->pixbuf ) {
            g_object_unref ( G_OBJECT (THIS->pixbuf) );
        }

        THIS->pixbuf = rsvg_pixbuf_from_file( svgfile, NULL );

        if( THIS->pixbuf ) {
            RETVAL = 1;
        } else {
            RETVAL = 0;
        }
#line 1115 "LibRSVG.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Image__LibRSVG_loadFromString); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Image__LibRSVG_loadFromString)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "THIS, svg, dpi=0");
    {
	char *	svg = (char *)SvPV_nolen(ST(1))
;
	double	dpi;
	SVGLibRSVG *	THIS;
	int	RETVAL;
	dXSTARG;

	if (items < 3)
	    dpi = 0;
	else {
	    dpi = (double)SvNV(ST(2))
;
	}

        if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG)
        {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
          THIS = INT2PTR(SVGLibRSVG *, tmp);
        }
        else
          Perl_croak(aTHX_ "Image::LibRSVG::loadFromString(): THIS is not a blessed SV reference")
;
#line 647 "LibRSVG.xs"
        g_type_init ();

        if (dpi > 0.) {
            rsvg_set_default_dpi (dpi);
        }

        if( THIS->pixbuf ) {
            g_object_unref ( G_OBJECT (THIS->pixbuf) );
        }

        THIS->pixbuf = rsvg_pixbuf_from_chars( svg, NULL );

        if( THIS->pixbuf ) 
        {
            RETVAL = 1;
        } 
        else 
        {
            RETVAL = 0;
        }
#line 1172 "LibRSVG.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Image__LibRSVG_loadFromFileAtZoom); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Image__LibRSVG_loadFromFileAtZoom)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "THIS, svgfile, x_zoom, y_zoom, dpi=0");
    {
	char *	svgfile = (char *)SvPV_nolen(ST(1))
;
	double	x_zoom = (double)SvNV(ST(2))
;
	double	y_zoom = (double)SvNV(ST(3))
;
	double	dpi;
	SVGLibRSVG *	THIS;
	int	RETVAL;
	dXSTARG;

	if (items < 5)
	    dpi = 0;
	else {
	    dpi = (double)SvNV(ST(4))
;
	}

        if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG)
        {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
          THIS = INT2PTR(SVGLibRSVG *, tmp);
        }
        else
          Perl_croak(aTHX_ "Image::LibRSVG::loadFromFileAtZoom(): THIS is not a blessed SV reference")
;
#line 681 "LibRSVG.xs"
        g_type_init ();

        if (dpi > 0.) {
            rsvg_set_default_dpi (dpi);
        }

        if( THIS->pixbuf ) {
            g_object_unref ( G_OBJECT (THIS->pixbuf) );
        }

        THIS->pixbuf = rsvg_pixbuf_from_file_at_zoom( svgfile, x_zoom, y_zoom, NULL );

        if( THIS->pixbuf ) {
            RETVAL = 1;
        } else {
            RETVAL = 0;
        }
#line 1230 "LibRSVG.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Image__LibRSVG_loadFromStringAtZoom); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Image__LibRSVG_loadFromStringAtZoom)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "THIS, svg, x_zoom, y_zoom, dpi=0");
    {
	char *	svg = (char *)SvPV_nolen(ST(1))
;
	double	x_zoom = (double)SvNV(ST(2))
;
	double	y_zoom = (double)SvNV(ST(3))
;
	double	dpi;
	SVGLibRSVG *	THIS;
	int	RETVAL;
	dXSTARG;

	if (items < 5)
	    dpi = 0;
	else {
	    dpi = (double)SvNV(ST(4))
;
	}

        if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG)
        {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
          THIS = INT2PTR(SVGLibRSVG *, tmp);
        }
        else
          Perl_croak(aTHX_ "Image::LibRSVG::loadFromStringAtZoom(): THIS is not a blessed SV reference")
;
#line 709 "LibRSVG.xs"
        g_type_init ();

        if (dpi > 0.) {
            rsvg_set_default_dpi (dpi);
        }

        if( THIS->pixbuf ) {
            g_object_unref ( G_OBJECT (THIS->pixbuf) );
        }

        THIS->pixbuf = rsvg_pixbuf_from_chars_at_zoom( svg, x_zoom, y_zoom, NULL );

        if( THIS->pixbuf ) {
            RETVAL = 1;
        } else {
            RETVAL = 0;
        }
#line 1288 "LibRSVG.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Image__LibRSVG_loadFromFileAtMaxSize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Image__LibRSVG_loadFromFileAtMaxSize)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "THIS, svgfile, width, height, dpi=0");
    {
	char *	svgfile = (char *)SvPV_nolen(ST(1))
;
	int	width = (int)SvIV(ST(2))
;
	int	height = (int)SvIV(ST(3))
;
	double	dpi;
	SVGLibRSVG *	THIS;
	int	RETVAL;
	dXSTARG;

	if (items < 5)
	    dpi = 0;
	else {
	    dpi = (double)SvNV(ST(4))
;
	}

        if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG)
        {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
          THIS = INT2PTR(SVGLibRSVG *, tmp);
        }
        else
          Perl_croak(aTHX_ "Image::LibRSVG::loadFromFileAtMaxSize(): THIS is not a blessed SV reference")
;
#line 741 "LibRSVG.xs"
        g_type_init ();

        if (dpi > 0.) {
            rsvg_set_default_dpi (dpi);
        }

        if( THIS->pixbuf ) {
            g_object_unref ( G_OBJECT (THIS->pixbuf) );
        }

        THIS->pixbuf = rsvg_pixbuf_from_file_at_max_size( svgfile, width, height, NULL );

        if( THIS->pixbuf ) {
            RETVAL = 1;
        } else {
            RETVAL = 0;
        }
#line 1346 "LibRSVG.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Image__LibRSVG_loadFromStringAtMaxSize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Image__LibRSVG_loadFromStringAtMaxSize)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "THIS, svgfile, width, height, dpi=0");
    {
	char *	svgfile = (char *)SvPV_nolen(ST(1))
;
	int	width = (int)SvIV(ST(2))
;
	int	height = (int)SvIV(ST(3))
;
	double	dpi;
	SVGLibRSVG *	THIS;
	int	RETVAL;
	dXSTARG;

	if (items < 5)
	    dpi = 0;
	else {
	    dpi = (double)SvNV(ST(4))
;
	}

        if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG)
        {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
          THIS = INT2PTR(SVGLibRSVG *, tmp);
        }
        else
          Perl_croak(aTHX_ "Image::LibRSVG::loadFromStringAtMaxSize(): THIS is not a blessed SV reference")
;
#line 769 "LibRSVG.xs"
        g_type_init ();

        if (dpi > 0.) {
            rsvg_set_default_dpi (dpi);
        }

        if( THIS->pixbuf ) {
            g_object_unref ( G_OBJECT (THIS->pixbuf) );
        }

        THIS->pixbuf = rsvg_pixbuf_from_chars_at_max_size( svgfile, width, height, NULL );

        if( THIS->pixbuf ) {
            RETVAL = 1;
        } else {
            RETVAL = 0;
        }
#line 1404 "LibRSVG.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Image__LibRSVG_loadFromFileAtSize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Image__LibRSVG_loadFromFileAtSize)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "THIS, svgfile, width, height, dpi=0");
    {
	char *	svgfile = (char *)SvPV_nolen(ST(1))
;
	int	width = (int)SvIV(ST(2))
;
	int	height = (int)SvIV(ST(3))
;
	double	dpi;
	SVGLibRSVG *	THIS;
	int	RETVAL;
	dXSTARG;

	if (items < 5)
	    dpi = 0;
	else {
	    dpi = (double)SvNV(ST(4))
;
	}

        if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG)
        {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
          THIS = INT2PTR(SVGLibRSVG *, tmp);
        }
        else
          Perl_croak(aTHX_ "Image::LibRSVG::loadFromFileAtSize(): THIS is not a blessed SV reference")
;
#line 801 "LibRSVG.xs"
        g_type_init ();

        if (dpi > 0.) {
            rsvg_set_default_dpi (dpi);
        }

        if( THIS->pixbuf ) {
            g_object_unref ( G_OBJECT (THIS->pixbuf) );
        }

        THIS->pixbuf = rsvg_pixbuf_from_file_at_size( svgfile, width, height, NULL );

        if( THIS->pixbuf ) {
            RETVAL = 1;
        } else {
            RETVAL = 0;
        }
#line 1462 "LibRSVG.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Image__LibRSVG_loadFromStringAtSize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Image__LibRSVG_loadFromStringAtSize)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "THIS, svgfile, width, height, dpi=0");
    {
	char *	svgfile = (char *)SvPV_nolen(ST(1))
;
	int	width = (int)SvIV(ST(2))
;
	int	height = (int)SvIV(ST(3))
;
	double	dpi;
	SVGLibRSVG *	THIS;
	int	RETVAL;
	dXSTARG;

	if (items < 5)
	    dpi = 0;
	else {
	    dpi = (double)SvNV(ST(4))
;
	}

        if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG)
        {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
          THIS = INT2PTR(SVGLibRSVG *, tmp);
        }
        else
          Perl_croak(aTHX_ "Image::LibRSVG::loadFromStringAtSize(): THIS is not a blessed SV reference")
;
#line 829 "LibRSVG.xs"
        g_type_init ();

        if (dpi > 0.) {
            rsvg_set_default_dpi (dpi);
        }

        if( THIS->pixbuf ) {
            g_object_unref ( G_OBJECT (THIS->pixbuf) );
        }

        THIS->pixbuf = rsvg_pixbuf_from_chars_at_size( svgfile, width, height, NULL );

        if( THIS->pixbuf ) {
            RETVAL = 1;
        } else {
            RETVAL = 0;
        }
#line 1520 "LibRSVG.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Image__LibRSVG_loadFromFileAtZoomWithMax); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Image__LibRSVG_loadFromFileAtZoomWithMax)
{
    dVAR; dXSARGS;
    if (items < 6 || items > 7)
       croak_xs_usage(cv,  "THIS, svgfile, x_zoom, y_zoom, width, height, dpi=0");
    {
	char *	svgfile = (char *)SvPV_nolen(ST(1))
;
	double	x_zoom = (double)SvNV(ST(2))
;
	double	y_zoom = (double)SvNV(ST(3))
;
	int	width = (int)SvIV(ST(4))
;
	int	height = (int)SvIV(ST(5))
;
	double	dpi;
	SVGLibRSVG *	THIS;
	int	RETVAL;
	dXSTARG;

	if (items < 7)
	    dpi = 0;
	else {
	    dpi = (double)SvNV(ST(6))
;
	}

        if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG)
        {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
          THIS = INT2PTR(SVGLibRSVG *, tmp);
        }
        else
          Perl_croak(aTHX_ "Image::LibRSVG::loadFromFileAtZoomWithMax(): THIS is not a blessed SV reference")
;
#line 864 "LibRSVG.xs"
        GdkPixbuf *pixbuf;

        g_type_init ();

        if (dpi > 0.) {
            rsvg_set_default_dpi (dpi);
        }

        if( THIS->pixbuf ) {
            g_object_unref ( G_OBJECT (THIS->pixbuf) );
        }

        THIS->pixbuf = rsvg_pixbuf_from_file_at_zoom_with_max( svgfile, x_zoom, y_zoom, width, height, NULL );

        if( THIS->pixbuf ) {
            RETVAL = 1;
        } else {
            RETVAL = 0;
        }
#line 1584 "LibRSVG.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Image__LibRSVG_loadFromStringAtZoomWithMax); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Image__LibRSVG_loadFromStringAtZoomWithMax)
{
    dVAR; dXSARGS;
    if (items < 6 || items > 7)
       croak_xs_usage(cv,  "THIS, svgfile, x_zoom, y_zoom, width, height, dpi=0");
    {
	char *	svgfile = (char *)SvPV_nolen(ST(1))
;
	double	x_zoom = (double)SvNV(ST(2))
;
	double	y_zoom = (double)SvNV(ST(3))
;
	int	width = (int)SvIV(ST(4))
;
	int	height = (int)SvIV(ST(5))
;
	double	dpi;
	SVGLibRSVG *	THIS;
	int	RETVAL;
	dXSTARG;

	if (items < 7)
	    dpi = 0;
	else {
	    dpi = (double)SvNV(ST(6))
;
	}

        if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG)
        {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
          THIS = INT2PTR(SVGLibRSVG *, tmp);
        }
        else
          Perl_croak(aTHX_ "Image::LibRSVG::loadFromStringAtZoomWithMax(): THIS is not a blessed SV reference")
;
#line 895 "LibRSVG.xs"
        GdkPixbuf *pixbuf;

        g_type_init ();

        if (dpi > 0.) {
            rsvg_set_default_dpi (dpi);
        }

        if( THIS->pixbuf ) {
            g_object_unref ( G_OBJECT (THIS->pixbuf) );
        }

        THIS->pixbuf = rsvg_pixbuf_from_chars_at_zoom_with_max( svgfile, x_zoom, y_zoom, width, height, NULL );

        if( THIS->pixbuf ) {
            RETVAL = 1;
        } else {
            RETVAL = 0;
        }
#line 1648 "LibRSVG.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Image__LibRSVG_saveAs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Image__LibRSVG_saveAs)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "THIS, bitmapfile, format=\"png\", quality=100");
    {
	char *	bitmapfile = (char *)SvPV_nolen(ST(1))
;
	char *	format;
	int	quality;
	SVGLibRSVG *	THIS;
	int	RETVAL;
	dXSTARG;

	if (items < 3)
	    format = "png";
	else {
	    format = (char *)SvPV_nolen(ST(2))
;
	}

	if (items < 4)
	    quality = 100;
	else {
	    quality = (int)SvIV(ST(3))
;
	}

        if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG)
        {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
          THIS = INT2PTR(SVGLibRSVG *, tmp);
        }
        else
          Perl_croak(aTHX_ "Image::LibRSVG::saveAs(): THIS is not a blessed SV reference")
;
#line 927 "LibRSVG.xs"
        if( THIS->pixbuf ) {
            RETVAL = save( quality, format, THIS->pixbuf, bitmapfile );
        } else {
            RETVAL = 0;
        }
#line 1698 "LibRSVG.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#if GDK_PIXBUF_MAJOR > 2 || ( GDK_PIXBUF_MAJOR == 2 && GDK_PIXBUF_MINOR >= 4 )
#define XSubPPtmpAAAA 1


XS_EUPXS(XS_Image__LibRSVG_getImageBitmap); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Image__LibRSVG_getImageBitmap)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "THIS, format=\"png\", quality=100");
    {
	char *	format;
	int	quality;
	SVGLibRSVG *	THIS;
	SV *	RETVAL;

	if (items < 2)
	    format = "png";
	else {
	    format = (char *)SvPV_nolen(ST(1))
;
	}

	if (items < 3)
	    quality = 100;
	else {
	    quality = (int)SvIV(ST(2))
;
	}

        if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG)
        {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
          THIS = INT2PTR(SVGLibRSVG *, tmp);
        }
        else
          Perl_croak(aTHX_ "Image::LibRSVG::getImageBitmap(): THIS is not a blessed SV reference")
;
#line 950 "LibRSVG.xs"
        GError *      my_error_p = NULL;
        gboolean      ret;
        gsize         buffer_size;
        gchar *       buffer;

        buffer_size = SVG_BUFFER_SIZE;

        char * quality_str;

        if (strcmp (format, "jpeg") != 0 || (quality < 1 || quality > 100)) 
        {
            if( ! gdk_pixbuf_save_to_buffer (THIS->pixbuf, &buffer, &buffer_size, format, &my_error_p, "tEXt::Software", "testpixbuf-save",NULL) ) {
                fprintf (stderr, "%s", my_error_p->message);
                g_error_free (my_error_p);
            } else {
                RETVAL = newSVpv( buffer, buffer_size );
                g_free( buffer );
            }
        }
        else 
        {
            quality_str = g_strdup_printf ("%d", quality);
            if( ! gdk_pixbuf_save_to_buffer (THIS->pixbuf, &buffer, &buffer_size, format, &my_error_p, "quality", quality_str, NULL) ) {
                fprintf (stderr, "%s", my_error_p->message);
                g_error_free (my_error_p);
            } else {
                RETVAL = newSVpv( buffer, buffer_size );
                g_free( buffer );
            }
            g_free (quality_str);
        }
#line 1774 "LibRSVG.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#else
#define XSubPPtmpAAAB 1


XS_EUPXS(XS_Image__LibRSVG_getImageBitmap); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Image__LibRSVG_getImageBitmap)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "THIS, format=\"png\", quality=100");
    {
	char *	format;
	int	quality;
	SVGLibRSVG *	THIS;
	SV *	RETVAL;

	if (items < 2)
	    format = "png";
	else {
	    format = (char *)SvPV_nolen(ST(1))
;
	}

	if (items < 3)
	    quality = 100;
	else {
	    quality = (int)SvIV(ST(2))
;
	}

        if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG)
        {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
          THIS = INT2PTR(SVGLibRSVG *, tmp);
        }
        else
          Perl_croak(aTHX_ "Image::LibRSVG::getImageBitmap(): THIS is not a blessed SV reference")
;
#line 990 "LibRSVG.xs"
        RETVAL = NULL;
#line 1821 "LibRSVG.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#endif
#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Image__LibRSVG); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Image__LibRSVG)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("Image::LibRSVG::new", XS_Image__LibRSVG_new, file, "$");
        (void)newXSproto_portable("Image::LibRSVG::DESTROY", XS_Image__LibRSVG_DESTROY, file, "$");
        (void)newXSproto_portable("Image::LibRSVG::getSupportedFormats", XS_Image__LibRSVG_getSupportedFormats, file, "$");
        (void)newXSproto_portable("Image::LibRSVG::getKnownFormats", XS_Image__LibRSVG_getKnownFormats, file, "$");
        (void)newXSproto_portable("Image::LibRSVG::isFormatSupported", XS_Image__LibRSVG_isFormatSupported, file, "$$");
        (void)newXSproto_portable("Image::LibRSVG::isGzCompressionSupported", XS_Image__LibRSVG_isGzCompressionSupported, file, "$");
        (void)newXSproto_portable("Image::LibRSVG::convert", XS_Image__LibRSVG_convert, file, "$$$;$$$");
        (void)newXSproto_portable("Image::LibRSVG::convertAtZoom", XS_Image__LibRSVG_convertAtZoom, file, "$$$$$;$$$");
        (void)newXSproto_portable("Image::LibRSVG::convertAtMaxSize", XS_Image__LibRSVG_convertAtMaxSize, file, "$$$$$;$$$");
        (void)newXSproto_portable("Image::LibRSVG::convertAtSize", XS_Image__LibRSVG_convertAtSize, file, "$$$$$;$$$");
        (void)newXSproto_portable("Image::LibRSVG::convertAtZoomWithMax", XS_Image__LibRSVG_convertAtZoomWithMax, file, "$$$$$$$;$$$");
        (void)newXSproto_portable("Image::LibRSVG::loadFromFile", XS_Image__LibRSVG_loadFromFile, file, "$$;$");
        (void)newXSproto_portable("Image::LibRSVG::loadFromString", XS_Image__LibRSVG_loadFromString, file, "$$;$");
        (void)newXSproto_portable("Image::LibRSVG::loadFromFileAtZoom", XS_Image__LibRSVG_loadFromFileAtZoom, file, "$$$$;$");
        (void)newXSproto_portable("Image::LibRSVG::loadFromStringAtZoom", XS_Image__LibRSVG_loadFromStringAtZoom, file, "$$$$;$");
        (void)newXSproto_portable("Image::LibRSVG::loadFromFileAtMaxSize", XS_Image__LibRSVG_loadFromFileAtMaxSize, file, "$$$$;$");
        (void)newXSproto_portable("Image::LibRSVG::loadFromStringAtMaxSize", XS_Image__LibRSVG_loadFromStringAtMaxSize, file, "$$$$;$");
        (void)newXSproto_portable("Image::LibRSVG::loadFromFileAtSize", XS_Image__LibRSVG_loadFromFileAtSize, file, "$$$$;$");
        (void)newXSproto_portable("Image::LibRSVG::loadFromStringAtSize", XS_Image__LibRSVG_loadFromStringAtSize, file, "$$$$;$");
        (void)newXSproto_portable("Image::LibRSVG::loadFromFileAtZoomWithMax", XS_Image__LibRSVG_loadFromFileAtZoomWithMax, file, "$$$$$$;$");
        (void)newXSproto_portable("Image::LibRSVG::loadFromStringAtZoomWithMax", XS_Image__LibRSVG_loadFromStringAtZoomWithMax, file, "$$$$$$;$");
        (void)newXSproto_portable("Image::LibRSVG::saveAs", XS_Image__LibRSVG_saveAs, file, "$$;$$");
#if XSubPPtmpAAAA
        (void)newXSproto_portable("Image::LibRSVG::getImageBitmap", XS_Image__LibRSVG_getImageBitmap, file, "$;$$");
#endif
#if XSubPPtmpAAAB
        (void)newXSproto_portable("Image::LibRSVG::getImageBitmap", XS_Image__LibRSVG_getImageBitmap, file, "$;$$");
#endif

    /* Initialisation Section */

#if XSubPPtmpAAAA
#endif
#if XSubPPtmpAAAB
#endif
#line 1892 "LibRSVG.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

